
var standardogame_gmCompiler={
	//GETS A SOURCE FROM AN URL AND RETURNS IT AS A STRING
	getUrlContents: function(aUrl){
		var	ioService=Components.classes["@mozilla.org/network/io-service;1"]
			.getService(Components.interfaces.nsIIOService);
		var	scriptableStream=Components
			.classes["@mozilla.org/scriptableinputstream;1"]
			.getService(Components.interfaces.nsIScriptableInputStream);

		var	channel=ioService.newChannel(aUrl, null, null);
		var	input=channel.open();
		scriptableStream.init(input);
		var	str=scriptableStream.read(input.available());
		scriptableStream.close();
		input.close();

		return str;
	},

	isGreasemonkeyable: function(url) {
		var scheme=Components.classes["@mozilla.org/network/io-service;1"]
			.getService(Components.interfaces.nsIIOService)
			.extractScheme(url);
		return (
			(scheme == "http" || scheme == "https" || scheme == "file") &&
			!/hiddenWindow\.html$/.test(url)
		);
	},

	contentLoad: function(e) {
		var unsafeWin=e.target.defaultView;
		if (unsafeWin.wrappedJSObject) unsafeWin=unsafeWin.wrappedJSObject;

		var unsafeLoc=new XPCNativeWrapper(unsafeWin, "location").location;
		var href=new XPCNativeWrapper(unsafeLoc, "href").href;
		if (
			standardogame_gmCompiler.isGreasemonkeyable(href)
			&& true
			&& true
		) {
			var script=standardogame_gmCompiler.getUrlContents(
				'chrome://standardogame/content/load/standardogame.js'
			);
			standardogame_gmCompiler.injectScript(script, href, unsafeWin);
		}
	},

	injectScript: function(script, url, unsafeContentWin) {
		var sandbox, script, logger, storage, xmlhttpRequester;
		var safeWin=new XPCNativeWrapper(unsafeContentWin);

		sandbox=new Components.utils.Sandbox(safeWin);

		var storage=new standardogame_ScriptStorage();
		xmlhttpRequester=new standardogame_xmlhttpRequester(
			unsafeContentWin, window//appSvc.hiddenDOMWindow
		);

		sandbox.window=safeWin;
		sandbox.document=sandbox.window.document;
		sandbox.unsafeWindow=unsafeContentWin;
		// patch missing properties on xpcnw
		sandbox.XPathResult=Components.interfaces.nsIDOMXPathResult;

		// add our own APIs
		sandbox.GM_addStyle=function(css){standardogame_gmCompiler.addStyle(sandbox.document, css) };
		sandbox.GM_setValue=standardogame_gmCompiler.hitch(storage, "setValue");
		sandbox.GM_getValue=standardogame_gmCompiler.hitch(storage, "getValue");
		sandbox.GM_openInTab=standardogame_gmCompiler.hitch(this, "openInTab", unsafeContentWin);
		sandbox.GM_xmlhttpRequest=standardogame_gmCompiler.hitch(xmlhttpRequester, "contentStartRequest");
		//unsupported
		sandbox.GM_registerMenuCommand=function(){};
		sandbox.GM_log=function(){};
		
		sandbox.ST_parseInt=function(numbertoconvert){
			if(numbertoconvert){
				numbertoconvert = String(numbertoconvert);
				numbertoconvert=parseInt(numbertoconvert.replace(/\./g, ""), 10);
				if(isNaN(numbertoconvert)){
					return 0;
				}else{
					return numbertoconvert;
				}
			}else{
				return 0;
			}
		}

		sandbox.ST_SubSetValue=function(subscriptname, val){
			sandbox.ST_setValue("sub."+subscriptname+".sav."+sandbox.SaveCoords, val);
		}

		sandbox.ST_SubGetValue=function(subscriptname, val){
			return sandbox.ST_getValue("sub."+subscriptname+".sav."+sandbox.SaveCoords, val);
		}

		sandbox.ST_serverName=function(){
			if(sandbox.document.location.href.indexOf("standardogamegmsaveid=")>0){
				return sandbox.document.location.href.split("standardogamegmsaveid=")[1].split("|")[1].split("&")[0];
			}else{
				if(sandbox.document.location.href.indexOf("http://")>=0){
					return sandbox.document.location.href.split("http://")[1].split("/")[0];
				}else{
					return -1;
				}
			}
		}

		sandbox.ST_serverVersion=function(){
			if(sandbox.document.location.href.indexOf("/game/index.php?page=")>0){
				for(getversionlinksshuffle=sandbox.document.getElementsByTagName("a"), shuffleversionlink=0;shuffleversionlink<getversionlinksshuffle.length;shuffleversionlink++){
					if(typeof getversionlinksshuffle[shuffleversionlink].href!="undefined"){
						if(getversionlinksshuffle[shuffleversionlink].href.indexOf("/game/index.php?page=changelog")>0){
							sandbox.ST_setValue("serverversion."+sandbox.unis[sandbox.ServerName+".lng"]+"."+sandbox.unis[sandbox.ServerName+".nr"], getversionlinksshuffle[shuffleversionlink].innerHTML.split(" ")[1]);
							return getversionlinksshuffle[shuffleversionlink].innerHTML.split(" ")[1];
						}
					}
				}
				return sandbox.ST_getValue("serverversion."+sandbox.unis[sandbox.ServerName+".lng"]+"."+sandbox.unis[sandbox.ServerName+".nr"], -1);
			}
		}

		sandbox.ST_getPlayerID=function(){
			if(sandbox.document.location.href.indexOf("/game/index.php?page=overview")>0)
			{
				if (sandbox.document.body.innerHTML.indexOf('uid=')>=0){
					PlayerID=sandbox.ST_parseInt(sandbox.document.body.innerHTML.split("uid=")[1].split("&")[0]);
			    }else{
					PlayerID=sandbox.ST_getValue(sandbox.ServerName+".lastplayername", "noplayer");
				}
				sandbox.ST_setValue(sandbox.ServerName+".lastplayername", PlayerID);
			}else{
				PlayerID=sandbox.ST_getValue(sandbox.ServerName+".lastplayername", "noplayer");
			}
			if(sandbox.document.location.href.indexOf("standardogamegmsaveid=")>0)
			{
				PlayerID=sandbox.document.location.href.split("standardogamegmsaveid=")[1].replace(/\%7C/g,"|").split("|")[0].replace(/\%20/g," ");
			}
			return PlayerID;
		}

		sandbox.ST_getValue=function(address, defaultvalue){
			return sandbox.GM_getValue(address, defaultvalue);
		}

		sandbox.ST_setValue=function(address, value){
			sandbox.GM_setValue(address, value);
		}

		sandbox.ST_addPoint=function(num){
			num = String(num);
			var pointer;
			for(pointer = 3; pointer < num.length; pointer += 4){
				num = num.substr(0, num.length - pointer) + "." + num.substr(num.length - pointer);
			}
			return num;
		}

		sandbox.ST_getStyle=function(element, cssRule){
			if( sandbox.document.defaultView && sandbox.document.defaultView.getComputedStyle )
			{
				var value = sandbox.document.defaultView.getComputedStyle( element, '' ).getPropertyValue( 
					cssRule.replace( /[A-Z]/g, function( match, char ){return "-" + char.toLowerCase();})
				);
			}
			else if ( element.currentStyle )
				var value = element.currentStyle[ cssRule ];
			else
				var value = false;
			return value;
		}
		
		sandbox.ST_decToHex=function(dec){
		         dec = dec.replace("rgb(","").replace(")","");
		         var hex = "#";
		         for (cd = 0; cd < 3; cd++) {
		             var hexStr = "0123456789ABCDEF";
		             var low = Number(dec.split(", ")[cd]) % 16;
		             var high = (Number(dec.split(", ")[cd]) - low)/16;
		             hex += hexStr.charAt(high) + hexStr.charAt(low);
		         }
		         return hex;
		}

		sandbox.ST_loadCode=function(codelocation){
			return standardogame_gmCompiler.getUrlContents(codelocation);
		}
		sandbox.ST_error=function(sterror, subscriptwhereerrorwasfound){
			var e2=new Error(typeof sterror=="string" ? sterror : sterror.message);
			//e2.fileName=script.filename;
			e2.lineNumber=0;
			errdiv = sandbox.document.createElement("DIV");
			errdiv.setAttribute("style","{width: 300px; height: 100px; position: absolute; bottom: 10px; right: 20px; border-width: 1px 2px 2px 1px; border-style: solid; border-color: orangered red red orangered; background-image: url("+sandbox.hostingspace+"standardogamegm/mainproject/error_handling/img/main_error.png); z-index: 20000;}");
			errdiv.innerHTML="<center>If this error is not <a href='"+sandbox.hostingspace+"wiki/index.php?title=FAQ' target='_blank'>Known</a> please <a href='"+sandbox.hostingspace+"forum/posting.php?mode=post&f=20' target='_blank'>report</a> it."+
			"<br/>Copy the text below in your message on the board<br/><textarea style='{background: transparent none repeat scroll 0%; overflow-x: hidden; overflow-y: hidden; border: medium none;}' rows='3' cols='10' onClick='this.focus();this.select();' READONLY>"+
			"Error:\n[code]"+e2+"[/code]\n"+
			"SubScript:\n[code]"+subscriptwhereerrorwasfound+"[/code]\n"+
			"Line: "+e2.lineNumber+"\n\n"+
			"Url:\n[code]"+sandbox.document.location.href+"[/code]\n\n"+
			"Html:\n[code]"+sandbox.document.documentElement.innerHTML+"[/code]"+
			"</textarea></center>";
			sandbox.document.body.appendChild(errdiv);
		}
		
		sandbox.__proto__=sandbox.window;

		try {
			standardogame_gmCompiler.evalInSandbox(
				"(function(){"+script+"})()",
				url,
				sandbox);
		} catch (e) {
			sandbox.ST_error(e, "Main Launcher!")
		}
	},

	evalInSandbox: function(code, codebase, sandbox) {
		if (Components.utils && Components.utils.Sandbox) {
			// DP beta+
			Components.utils.evalInSandbox(code, sandbox);
		} else if (Components.utils && Components.utils.evalInSandbox) {
			// DP alphas
			Components.utils.evalInSandbox(code, codebase, sandbox);
		} else if (Sandbox) {
			// 1.0.x
			evalInSandbox(code, sandbox, codebase);
		} else {
			throw new Error("Could not create sandbox.");
		}
	},

	openInTab: function(unsafeContentWin, url) {
		var unsafeTop = new XPCNativeWrapper(unsafeContentWin, "top").top;

		for (var i = 0; i < this.browserWindows.length; i++) {
			this.browserWindows[i].openInTab(unsafeTop, url);
		}
	},

	hitch: function(obj, meth) {
		if (!obj[meth]) {
			throw "method '" + meth + "' does not exist on object '" + obj + "'";
		}

		var staticArgs = Array.prototype.splice.call(arguments, 2, arguments.length);

		return function() {
			// make a copy of staticArgs (don't modify it because it gets reused for
			// every invocation).
			var args = staticArgs.concat();

			// add all the new arguments
			for (var i = 0; i < arguments.length; i++) {
				args.push(arguments[i]);
			}

			// invoke the original function with the correct this obj and the combined
			// list of static and dynamic arguments.
			return obj[meth].apply(obj, args);
		};
	},

	addStyle: function(doc, css) {
		var head, style;
		head = doc.getElementsByTagName('head')[0];
		if (!head) { return; }
		style = doc.createElement('style');
		style.type = 'text/css';
		style.innerHTML = css;
		head.appendChild(style);
	},

	onLoad: function() {
		var	appcontent=window.document.getElementById("appcontent");
		if (appcontent && !appcontent.greased_standardogame_gmCompiler) {
			appcontent.greased_standardogame_gmCompiler=true;
			appcontent.addEventListener("DOMContentLoaded", standardogame_gmCompiler.contentLoad, false);
		}
	},

	onUnLoad: function() {
		//remove now unnecessary listeners
		window.removeEventListener('load', standardogame_gmCompiler.onLoad, false);
		window.removeEventListener('unload', standardogame_gmCompiler.onUnLoad, false);
		window.document.getElementById("appcontent")
			.removeEventListener("DOMContentLoaded", standardogame_gmCompiler.contentLoad, false);
	}

}; //object standardogame_gmCompiler


function standardogame_ScriptStorage() {
	this.prefMan=new standardogame_PrefManager();
}
standardogame_ScriptStorage.prototype.setValue = function(name, val) {
	this.prefMan.setValue(name, val);
}
standardogame_ScriptStorage.prototype.getValue = function(name, defVal) {
	return this.prefMan.getValue(name, defVal);
}